Imports System.ComponentModel

Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lstEmployees.Items.Add(New Employee("Abe", "Armand", 100, 7643, "B-246"))
        lstEmployees.Items.Add(New Employee("Bea", "Beecher", 200, 4091, "Q2-21"))
        lstEmployees.Items.Add(New Employee("Chaz", "Chemmy", 210, 2394, "Front B"))
        lstEmployees.Items.Add(New Employee("Dee", "Dart", 220, 1221, "Q72"))
        lstEmployees.Items.Add(New Employee("Ed", "Eagle", 300, 3201, "C-237"))
        lstEmployees.Items.Add(New Employee("Fran", "Finkle", 500, 1098, "A-001"))
    End Sub

    Private Sub lstEmployees_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstEmployees.SelectedIndexChanged
        Dim emp As Employee = DirectCast(lstEmployees.SelectedItem, Employee)
        PropertyGrid1.SelectedObject = emp
    End Sub
End Class

Public Class Employee
    ' The FirstName property.
    Private m_FirstName As String = ""
    <Description("The Employee's first name."), _
     Category("Data"), Browsable(True)> _
    Public Property FirstName() As String
        Get
            Return m_FirstName
        End Get
        Set(ByVal value As String)
            m_FirstName = value
        End Set
    End Property

    ' The LastName property.
    Private m_LastName As String = ""
    <Description("The Employee's last name."), _
     Category("Data"), Browsable(True)> _
    Public Property LastName() As String
        Get
            Return m_LastName
        End Get
        Set(ByVal value As String)
            m_LastName = value
        End Set
    End Property

    ' The EmployeeId property.
    Private m_EmployeeId As Integer = 0
    <Description("The Employee's ID number."), _
     Category("ID")> _
    Public Property EmployeeId() As Integer
        Get
            Return m_EmployeeId
        End Get
        Set(ByVal value As Integer)
            m_EmployeeId = value
        End Set
    End Property

    ' The Extension property.
    Private m_Extension As Integer = 0
    <Description("The Employee's extension."), _
     Category("ContactInfo")> _
    Public Property Extension() As Integer
        Get
            Return m_Extension
        End Get
        Set(ByVal value As Integer)
            m_Extension = value
        End Set
    End Property

    ' The Office property.
    Private m_Office As String = ""
    <Description("The Employee's building and office number."), _
     Category("ContactInfo")> _
    Public Property Office() As String
        Get
            Return m_Office
        End Get
        Set(ByVal value As String)
            m_Office = value
        End Set
    End Property

    Public Sub New(ByVal first_name As String, ByVal last_name As String, ByVal id As Integer, ByVal ext As Integer, ByVal the_office As String)
        FirstName = first_name
        LastName = last_name
        EmployeeId = id
        Extension = ext
        Office = the_office
    End Sub

    Public Overrides Function ToString() As String
        Return _
            FirstName & " " & _
            LastName & " (" & _
            EmployeeId.ToString() & ") x" & _
            Extension.ToString & " " & _
            Office
    End Function

End Class