'Imports System
Imports System.Security.Permissions

<Assembly: EventLogPermission( _
    SecurityAction.RequestMinimum, _
    PermissionAccess:=EventLogPermissionAccess.Administer)> 

Public Class Form1
    ' Connect to the log.
    Private Sub Form1_Load(ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles MyBase.Load
        ' Assert that we need permission to write to the event log.
        Dim log_permission As New EventLogPermission( _
                EventLogPermissionAccess.Administer, ".")
        Try
            log_permission.Assert()
            log_permission.Demand()
            log_permission.PermitOnly()
        Catch ex As Exception
            MessageBox.Show("This user does not have permission to write log entries", "No Permission", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Me.Close()
            Exit Sub
        End Try

        ' See if the log exists and create it if it doesn't.
        If Not EventLog.SourceExists("StatusSource") Then
            EventLog.CreateEventSource("StatusSource", "StatusLog")
            Debug.WriteLine("Creating event source")
        End If

        ' Set the EventLog component's source.
        logStatus.Source = "StatusSource"

        ' Write a Starting message to the log.
        logStatus.WriteEntry(Now & "> " & "Starting", _
            EventLogEntryType.Information)
        ShowLog()
    End Sub

    ' Write a Closing message to the log.
    Private Sub Form1_FormClosing(ByVal sender As Object, _
     ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ''logStatus.WriteEntry(Now & "> " & "Closing", _
        ''    EventLogEntryType.Information)
    End Sub

    ' Add an entry to the log.
    Private Sub btnAddToLog_Click(ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles btnAddToLog.Click
        logStatus.WriteEntry(Now & "> " & txtMessage.Text, _
            EventLogEntryType.Information)
        txtMessage.Text = ""
        txtMessage.Select(0, 0)
        ShowLog()
    End Sub

    ' Enable or disable btnAddToLog.
    Private Sub txtMessage_TextChanged(ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles txtMessage.TextChanged
        btnAddToLog.Enabled = (txtMessage.Text.Length > 0)
    End Sub

    ' Clear the log.
    Private Sub btnClearLog_Click(ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles btnClearLog.Click
        logStatus.Clear()
        ShowLog()
    End Sub

    ' List the items in the log.
    Private Sub ShowLog()
        lstLog.Items.Clear()

        For Each log_entry As EventLogEntry In logStatus.Entries
            lstLog.Items.Add(log_entry.Message)
        Next log_entry
        lstLog.SelectedIndex = lstLog.Items.Count - 1
    End Sub

    Private Sub lstLog_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles lstLog.DoubleClick
        Debug.WriteLine(lstLog.SelectedItem.ToString)
    End Sub
End Class
